package cn.ibizlab.businesscentral.core.odoo_product.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.HashMap;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.businesscentral.core.odoo_product.domain.Product_template_attribute_line;
import cn.ibizlab.businesscentral.core.odoo_product.filter.Product_template_attribute_lineSearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.alibaba.fastjson.JSONObject;

public interface Product_template_attribute_lineMapper extends BaseMapper<Product_template_attribute_line>{

    Page<Product_template_attribute_line> searchDefault(IPage page, @Param("srf") Product_template_attribute_lineSearchContext context, @Param("ew") Wrapper<Product_template_attribute_line> wrapper) ;
    @Override
    Product_template_attribute_line selectById(Serializable id);
    @Override
    int insert(Product_template_attribute_line entity);
    @Override
    int updateById(@Param(Constants.ENTITY) Product_template_attribute_line entity);
    @Override
    int update(@Param(Constants.ENTITY) Product_template_attribute_line entity, @Param("ew") Wrapper<Product_template_attribute_line> updateWrapper);
    @Override
    int deleteById(Serializable id);
     /**
      * 自定义查询SQL
      * @param sql
      * @return
      */
     @Select("${sql}")
     List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);

    List<Product_template_attribute_line> selectByAttributeId(@Param("id") Serializable id) ;

    List<Product_template_attribute_line> selectByProductTmplId(@Param("id") Serializable id) ;

    List<Product_template_attribute_line> selectByCreateUid(@Param("id") Serializable id) ;

    List<Product_template_attribute_line> selectByWriteUid(@Param("id") Serializable id) ;


}
